diff --git a/src/main/java/net/minecraft/core/block/TrommelBlock.java b/src/main/java/net/minecraft/core/block/BlockTrommel.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/TrommelBlock.java
rename to src/main/java/net/minecraft/core/block/BlockTrommel.java
index af600fa24..2f73d17eb 100644
--- a/src/main/java/net/minecraft/core/block/TrommelBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrommel.java
@@ -2,10 +2,9 @@ package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.TrommelBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -15,17 +14,17 @@ import org.slf4j.Logger;
 
 import java.util.Random;
 
-public class TrommelBlock extends RotatableEntityBlock
+public class BlockTrommel extends BlockTileEntityRotatable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-	public TrommelBlock(String key, String namespaceId, int id, Material material, boolean isActive)
+	public BlockTrommel(String key, String namespaceId, int id, Material material, boolean isActive)
     {
         super(key, namespaceId, id, material);
         this.isActive = isActive;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -43,7 +42,7 @@ public class TrommelBlock extends RotatableEntityBlock
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TrommelBlockEntity tileEntityTrommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getBlockEntity(x, y, z);
             player.displayTrommelScreen(tileEntityTrommel);
         }
         return true;
@@ -63,8 +62,8 @@ public class TrommelBlock extends RotatableEntityBlock
     public static void updateTrommelBlockState(boolean lit, World world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
-        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-        if(blockEntity == null) {
+        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        if(tileEntity == null) {
             String msg = "Trommel is missing Tile Entity at x: " + x + " y: " + y + " z: " + z + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
@@ -83,15 +82,15 @@ public class TrommelBlock extends RotatableEntityBlock
         }
         keepTrommelInventory = false;
         world.setBlockMetadataWithNotify(x, y, z, l);
-        blockEntity.validate();
-        world.setBlockTileEntity(x, y, z, blockEntity);
+        tileEntity.validate();
+        world.setBlockTileEntity(x, y, z, tileEntity);
     }
 
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new TrommelBlockEntity();
+        return new TileEntityTrommel();
     }
 
     private boolean isActive;
diff --git a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java b/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
rename to src/main/java/net/minecraft/core/block/BlockWireRedstone.java
index f6e1339a0..330017d43 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -19,11 +19,11 @@ import java.util.HashSet;
 import java.util.Random;
 import java.util.Set;
 
-public class RedstoneWireBlock extends Block {
+public class BlockWireRedstone extends Block {
     private boolean shouldSignal = true;
     private final Set<ChunkPosition> toUpdate = new HashSet<>();
 
-    public RedstoneWireBlock(String key, String namespaceId, int id) {
+    public BlockWireRedstone(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.decoration);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
     }
@@ -268,7 +268,7 @@ public class RedstoneWireBlock extends Block {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         return new ItemStack[]{new ItemStack(Items.DUST_REDSTONE)};
     }
 
@@ -373,7 +373,7 @@ public class RedstoneWireBlock extends Block {
         }
         if (blockId == Blocks.REPEATER_IDLE.id || blockId == Blocks.REPEATER_ACTIVE.id) {
             int meta = worldSource.getBlockMetadata(x, y, z);
-            return data == BedBlock.footToHeadMap[meta & 0b11];
+            return data == BlockBed.footToHeadMap[meta & 0b11];
         } else {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/WoolBlock.java b/src/main/java/net/minecraft/core/block/BlockWool.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/WoolBlock.java
rename to src/main/java/net/minecraft/core/block/BlockWool.java
index e0d5a70ed..9c15e00ca 100644
--- a/src/main/java/net/minecraft/core/block/WoolBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockWool.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -10,9 +10,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class WoolBlock extends Block implements IPainted
+public class BlockWool extends Block implements IPainted
 {
-    public WoolBlock(String key, String namespaceId, int id) {
+    public BlockWool(String key, String namespaceId, int id) {
 
         super(key, namespaceId, id, Material.cloth);
     }
@@ -23,7 +23,7 @@ public class WoolBlock extends Block implements IPainted
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return new ItemStack[] { new ItemStack(this, 1, meta) };
     }
diff --git a/src/main/java/net/minecraft/core/block/WorkbenchBlock.java b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/WorkbenchBlock.java
rename to src/main/java/net/minecraft/core/block/BlockWorkbench.java
index 5b300247e..9fd2a1763 100644
--- a/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
@@ -8,10 +8,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class WorkbenchBlock extends Block
+public class BlockWorkbench extends Block
 {
 
-	public WorkbenchBlock(String key, String namespaceId, int id)
+	public BlockWorkbench(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index bb0dec3aa..bcefa2819 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -2,25 +2,25 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
-import net.minecraft.core.block.piston.PistonBaseBlock;
-import net.minecraft.core.block.piston.PistonHeadBlock;
-import net.minecraft.core.block.piston.MovingPistonBlock;
-import net.minecraft.core.block.piston.SteelPistonBaseBlock;
-import net.minecraft.core.block.piston.StickyPistonBaseBlock;
+import net.minecraft.core.block.piston.BlockPistonBase;
+import net.minecraft.core.block.piston.BlockPistonHead;
+import net.minecraft.core.block.piston.BlockPistonMoving;
+import net.minecraft.core.block.piston.BlockPistonBaseSteel;
+import net.minecraft.core.block.piston.BlockPistonBaseSticky;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.item.block.AlgaeBlockItem;
-import net.minecraft.core.item.block.LadderBlockItem;
-import net.minecraft.core.item.block.LeavesLayerBlockItem;
-import net.minecraft.core.item.block.PaintedBlockItem;
-import net.minecraft.core.item.block.BlockItemStairsPainted;
-import net.minecraft.core.item.block.LampBlockItem;
-import net.minecraft.core.item.block.PaintedSlabBlockItem;
+import net.minecraft.core.item.block.ItemBlockAlgae;
+import net.minecraft.core.item.block.ItemBlockLadder;
+import net.minecraft.core.item.block.ItemBlockLayerLeaves;
+import net.minecraft.core.item.block.ItemBlockPainted;
+import net.minecraft.core.item.block.ItemBlockStairsPainted;
+import net.minecraft.core.item.block.ItemBlockLamp;
+import net.minecraft.core.item.block.ItemBlockSlabPainted;
 import net.minecraft.core.sound.BlockSounds;
 
 public final class Blocks {
@@ -447,7 +447,7 @@ public final class Blocks {
 
     public static void init(){
         setupBlocks();
-        MossBlock.initMossMap();
+        BlockMoss.initMossMap();
 
         for(int i = 0; i < Block.blocksList.length; i++)
         {
@@ -471,32 +471,32 @@ public final class Blocks {
     }
 
     public static void setupBlocks(){
-        STONE = new StoneBlock("stone", "minecraft:block/stone", 1, () -> Blocks.COBBLE_STONE, Material.stone).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
+        STONE = new BlockStone("stone", "minecraft:block/stone", 1, () -> Blocks.COBBLE_STONE, Material.stone).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
-        BASALT = new StoneBlock("basalt", "minecraft:block/basalt", 2, () -> Blocks.COBBLE_BASALT, Material.basalt).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
+        BASALT = new BlockStone("basalt", "minecraft:block/basalt", 2, () -> Blocks.COBBLE_BASALT, Material.basalt).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
-        LIMESTONE = new StoneBlock("limestone", "minecraft:block/limestone", 3, () -> Blocks.COBBLE_LIMESTONE, Material.limestone).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
+        LIMESTONE = new BlockStone("limestone", "minecraft:block/limestone", 3, () -> Blocks.COBBLE_LIMESTONE, Material.limestone).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
-        GRANITE = new StoneBlock("granite", "minecraft:block/granite", 4, () -> Blocks.COBBLE_GRANITE, Material.granite).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
+        GRANITE = new BlockStone("granite", "minecraft:block/granite", 4, () -> Blocks.COBBLE_GRANITE, Material.granite).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
         MARBLE = new Block("marble", "minecraft:block/marble", 5, Material.marble).withSound(BlockSounds.STONE).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         SLATE = new Block("slate", "minecraft:block/slate", 6, Material.slate).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        PERMAFROST = new StoneBlock("permafrost", "minecraft:block/permafrost", 7, () -> Blocks.COBBLE_PERMAFROST, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(1.5F).withBlastResistance(10F)
+        PERMAFROST = new BlockStone("permafrost", "minecraft:block/permafrost", 7, () -> Blocks.COBBLE_PERMAFROST, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
 
-        COBBLE_STONE = new CobbleBlock("cobble.stone", "minecraft:block/cobble_stone", 10, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_STONE = new BlockCobble("cobble.stone", "minecraft:block/cobble_stone", 10, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_STONE_MOSSY = new CobbleBlock("cobble.stone.mossy", "minecraft:block/cobble_stone_mossy", 11, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_STONE_MOSSY = new BlockCobble("cobble.stone.mossy", "minecraft:block/cobble_stone_mossy", 11, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_BASALT = new CobbleBlock("cobble.basalt", "minecraft:block/cobble_basalt", 12, Material.basalt, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_BASALT = new BlockCobble("cobble.basalt", "minecraft:block/cobble_basalt", 12, Material.basalt, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_LIMESTONE = new CobbleBlock("cobble.limestone", "minecraft:block/cobble_limestone", 13, Material.limestone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_LIMESTONE = new BlockCobble("cobble.limestone", "minecraft:block/cobble_limestone", 13, Material.limestone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_GRANITE = new CobbleBlock("cobble.granite", "minecraft:block/cobble_granite", 14, Material.granite, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_GRANITE = new BlockCobble("cobble.granite", "minecraft:block/cobble_granite", 14, Material.granite, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_PERMAFROST = new CobbleBlock("cobble.permafrost", "minecraft:block/cobble_permafrost", 15, Material.permafrost, () -> GRAVEL).withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_PERMAFROST = new BlockCobble("cobble.permafrost", "minecraft:block/cobble_permafrost", 15, Material.permafrost, () -> GRAVEL).withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         STONE_POLISHED = new Block("stone.polished", "minecraft:block/stone_polished", 860, Material.stone).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
@@ -514,7 +514,7 @@ public final class Blocks {
         NETHERRACK_POLISHED = new Block("netherrack.polished", "minecraft:block/netherrack_polished", 866, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-        PILLAR_MARBLE = new AxisAlignedBlock("pillar.marble", "minecraft:block/pillar_marble", 20, Material.marble).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+        PILLAR_MARBLE = new BlockAxisAligned("pillar.marble", "minecraft:block/pillar_marble", 20, Material.marble).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         CAPSTONE_MARBLE = new Block("capstone.marble", "minecraft:block/capstone_marble", 21, Material.marble).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
@@ -535,38 +535,38 @@ public final class Blocks {
         NETHERRACK_CARVED = new Block("netherrack.carved", "minecraft:block/netherrack_carved", 45, Material.netherrack).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withDisabledStats()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
-        PLANKS_OAK = new PlanksBlock("planks.oak", "minecraft:block/planks_oak", 50, Material.wood).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+        PLANKS_OAK = new BlockPlanks("planks.oak", "minecraft:block/planks_oak", 50, Material.wood).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
-        PLANKS_OAK_PAINTED = new PaintedPlanksBlock("planks.oak.painted", "minecraft:block/planks_oak_painted", 51).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
-            .setBlockItem((b) -> new PaintedBlockItem(b, false))
+        PLANKS_OAK_PAINTED = new BlockPlanksPainted("planks.oak.painted", "minecraft:block/planks_oak_painted", 51).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+            .setBlockItem((b) -> new ItemBlockPainted(b, false))
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
-        TORCH_COAL = new TorchBlock("torch.coal", "minecraft:block/torch_coal", 60).withSound(BlockSounds.WOOD).withHardness(0.0F).withLightEmission(0.9375F).withDisabledNeighborNotifyOnMetadataChange()
+        TORCH_COAL = new BlockTorch("torch.coal", "minecraft:block/torch_coal", 60).withSound(BlockSounds.WOOD).withHardness(0.0F).withLightEmission(0.9375F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS);
 
-        LADDER_OAK = new LadderBlock("ladder.oak", "minecraft:block/ladder_oak", 70).withSound(BlockSounds.WOOD).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
-            .setBlockItem((b) -> new LadderBlockItem((LadderBlock) b))
+        LADDER_OAK = new BlockLadder("ladder.oak", "minecraft:block/ladder_oak", 70).withSound(BlockSounds.WOOD).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
+            .setBlockItem((b) -> new ItemBlockLadder((BlockLadder) b))
             .withTags(BlockTags.MINEABLE_BY_AXE);
 
-        FENCE_PLANKS_OAK = new FenceBlock("fence.planks.oak", "minecraft:block/fence_planks_oak", 80).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+        FENCE_PLANKS_OAK = new BlockFence("fence.planks.oak", "minecraft:block/fence_planks_oak", 80).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE, BlockTags.CAN_HANG_OFF);
-        FENCE_PLANKS_OAK_PAINTED = new PaintedFenceBlock("fence.planks.oak.painted", "minecraft:block/fence_planks_oak_painted", 81).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
-            .setBlockItem((b) -> new PaintedBlockItem(b, false))
+        FENCE_PLANKS_OAK_PAINTED = new BlockFencePainted("fence.planks.oak.painted", "minecraft:block/fence_planks_oak_painted", 81).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+            .setBlockItem((b) -> new ItemBlockPainted(b, false))
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE, BlockTags.CAN_HANG_OFF);
 
-        FENCE_GATE_PLANKS_OAK = new FenceGateBlock("fencegate.planks.oak", "minecraft:block/fence_gate_planks_oak", 90).withSound(BlockSounds.WOOD).withHardness(2F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+        FENCE_GATE_PLANKS_OAK = new BlockFenceGate("fencegate.planks.oak", "minecraft:block/fence_gate_planks_oak", 90).withSound(BlockSounds.WOOD).withHardness(2F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
-        FENCE_GATE_PLANKS_OAK_PAINTED = new PaintedFenceGateBlock("fencegate.planks.oak.painted", "minecraft:block/fence_gate_planks_oak_painted", 91).withSound(BlockSounds.WOOD).withHardness(2F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
-            .setBlockItem((b) -> new PaintedBlockItem(b, true))
+        FENCE_GATE_PLANKS_OAK_PAINTED = new BlockFenceGatePainted("fencegate.planks.oak.painted", "minecraft:block/fence_gate_planks_oak_painted", 91).withSound(BlockSounds.WOOD).withHardness(2F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+            .setBlockItem((b) -> new ItemBlockPainted(b, true))
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
         BOOKSHELF_PLANKS_OAK = new Block("bookshelf.planks.oak", "minecraft:block/bookshelf_planks_oak", 100, Material.wood).withSound(BlockSounds.WOOD).withHardness(1.5F)
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
-        WOOL = new WoolBlock("wool", "minecraft:block/wool", 110).withSound(BlockSounds.CLOTH).withHardness(0.8F).withDisabledNeighborNotifyOnMetadataChange()
-            .setBlockItem((b) -> new PaintedBlockItem(b, false))
+        WOOL = new BlockWool("wool", "minecraft:block/wool", 110).withSound(BlockSounds.CLOTH).withHardness(0.8F).withDisabledNeighborNotifyOnMetadataChange()
+            .setBlockItem((b) -> new ItemBlockPainted(b, false))
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
-        ROPE = new RopeBlock("rope", "minecraft:block/rope", 111).withSound(BlockSounds.CLOTH).withHardness(0.01F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.ROPE)
+        ROPE = new BlockRope("rope", "minecraft:block/rope", 111).withSound(BlockSounds.CLOTH).withHardness(0.01F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.ROPE)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS, BlockTags.CAN_HANG_OFF, BlockTags.INSTANT_PICKUP);
 
         BRICK_CLAY = new Block("brick.clay", "minecraft:block/brick_clay", 120, Material.stone).withSound(BlockSounds.STONE).withHardness(3.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.brick)
